GNU bug report logs - #28670
df: detect over-mounted filesystems

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: coreutils; Severity: wishlist; Reported by: Alan Jenkins <alan.christopher.jenkins@HIDDEN>; merged with #28991; dated Mon, 2 Oct 2017 15:38:01 UTC; Maintainer for coreutils is bug-coreutils@HIDDEN.
Merged 28670 28991. Request was from Assaf Gordon <assafgordon@HIDDEN> to control <at> debbugs.gnu.org. Full text available.
Changed bug title to 'df: detect over-mounted filesystems' from 'df: detection of overmounted filesystems is not quite complete' Request was from Assaf Gordon <assafgordon@HIDDEN> to control <at> debbugs.gnu.org. Full text available.
Severity set to 'wishlist' from 'normal' Request was from Assaf Gordon <assafgordon@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 28670 <at> debbugs.gnu.org:


Received: (at 28670) by debbugs.gnu.org; 26 Oct 2017 04:48:14 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Oct 26 00:48:14 2017
Received: from localhost ([127.0.0.1]:33829 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1e7a5W-00016p-E1
	for submit <at> debbugs.gnu.org; Thu, 26 Oct 2017 00:48:14 -0400
Received: from mail.magicbluesmoke.com ([82.195.144.49]:35058)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <P@HIDDEN>)
 id 1e7a5U-00016d-SL; Thu, 26 Oct 2017 00:48:13 -0400
Received: from localhost.localdomain (c-73-158-116-184.hsd1.ca.comcast.net
 [73.158.116.184])
 (using TLSv1.2 with cipher ECDHE-RSA-AES128-GCM-SHA256 (128/128 bits))
 (No client certificate requested)
 by mail.magicbluesmoke.com (Postfix) with ESMTPSA id 80ADD9C32;
 Thu, 26 Oct 2017 05:48:11 +0100 (IST)
Subject: Re: bug#28991: df: wrong output when a FS masks another one
To: Stephane Chazelas <stephane.chazelas@HIDDEN>, 28991 <at> debbugs.gnu.org,
 28670 <at> debbugs.gnu.org
References: <20171025145715.GE5071@HIDDEN>
From: =?UTF-8?Q?P=c3=a1draig_Brady?= <P@HIDDEN>
Message-ID: <35fc7d85-351d-f496-644b-0c78af40e105@HIDDEN>
Date: Wed, 25 Oct 2017 21:48:09 -0700
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:45.0) Gecko/20100101
 Thunderbird/45.8.0
MIME-Version: 1.0
In-Reply-To: <20171025145715.GE5071@HIDDEN>
Content-Type: text/plain; charset=windows-1252
Content-Transfer-Encoding: 8bit
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 28670
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.0 (/)

On 25/10/17 07:57, Stephane Chazelas wrote:
> Test case:
> 
> /tmp$ mkdir -p 1/2
> /tmp$ sudo mount -o size=1M -t tmpfs x 1/2
> /tmp$ sudo mount -o size=2M -t tmpfs y 1
> /tmp$ mkdir 1/2
> /tmp$ df -h 1/2
> Filesystem      Size  Used Avail Use% Mounted on
> x               2.0M     0  2.0M   0% /tmp/1/2
> 
> The Size is correct as that's obtained from statfs() on the
> file. But when it comes to finding the corresponding mount
> source and mountpoint, it fails.
> 
> /tmp$ grep /tmp/ /proc/mounts
> x /tmp/1/2 tmpfs rw,relatime,size=1024k 0 0
> y /tmp/1 tmpfs rw,relatime,size=2048k 0 0
> 
> df should walk /proc/self/mounts or /etc/mtab from the bottom up
> until it finds the first mount point that is a parent of the
> realpath of the file.
> 
> /tmp$ df --version
> df (GNU coreutils) 8.28
> 
> (on Debian testing amd64)
> 
> 
> Related: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=15955
> 
> That's just been discussed on the austin group mailing list:
> https://www.mail-archive.com/austin-group-l@HIDDEN/msg01715.html
> https://www.mail-archive.com/austin-group-l@HIDDEN/msg01720.html
> 
> Not critical as that could be considered as a pathological test
> case.
> 

Yes it would be nice to behave more consistently here.
Also related is https://bugs.gnu.org/28670

cheers,
PŠdraig




Information forwarded to bug-coreutils@HIDDEN:
bug#28670; Package coreutils. Full text available.

Message received at 28670 <at> debbugs.gnu.org:


Received: (at 28670) by debbugs.gnu.org; 2 Oct 2017 16:57:56 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Oct 02 12:57:56 2017
Received: from localhost ([127.0.0.1]:44436 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1dz42W-0006Pv-Db
	for submit <at> debbugs.gnu.org; Mon, 02 Oct 2017 12:57:56 -0400
Received: from mail-wm0-f50.google.com ([74.125.82.50]:46074)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <alan.christopher.jenkins@HIDDEN>)
 id 1dz33j-0004nl-0m
 for 28670 <at> debbugs.gnu.org; Mon, 02 Oct 2017 11:55:07 -0400
Received: by mail-wm0-f50.google.com with SMTP id q124so11521817wmb.0
 for <28670 <at> debbugs.gnu.org>; Mon, 02 Oct 2017 08:55:06 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=to:from:subject:message-id:date:user-agent:mime-version
 :content-transfer-encoding:content-language;
 bh=OkB2gMMcF6CqZWISWyxIn+u/xOBoCsB0Rbzw28yo7Jg=;
 b=P+AILqv3cMfZHjRk9VRTCh+ZhIcY1JNS8Y4iXjaqYVW85PWaIdBjuiYQGeTPdXX+k6
 Rkf+Eso1JZoqEHXOhMmQiJhN5FCpi7jklD6AKjxLb8KI0nGtSnpJxzn9TwidVzw71xBq
 XpeW8TJivqZfCtXXa158/wCxXDZMBruu4sDaY6/7Jo39m4vLG3VLY6sgD/d+uAoNMYts
 sgrCkGJVyqmkjilsx7Y56hdTfO3RcMyQIx5GhE0fHw5arKAaY+QMp4mzxm4BTfIIzsqE
 GYtOq5qjWOmL6ntdzpKtqT7t0Vvrg16bmmqXDTDxb4alAsGoYl+zpWxy9IyKYfMgn4Wa
 bgkw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:to:from:subject:message-id:date:user-agent
 :mime-version:content-transfer-encoding:content-language;
 bh=OkB2gMMcF6CqZWISWyxIn+u/xOBoCsB0Rbzw28yo7Jg=;
 b=ZZaRPOj77T3+Mr1zsOlx6Jv+2LtRFyVjVnNnkKFEGut1ipTQPpUXeFSng0q55+HtSE
 q7awyfOTYxRTPS9PvtEe6igQwgOb94cmU26PvClDpkh32cOuB7g15KiIp8taShVlaQ3m
 l2mhNA7EUt73Pr0/Vpcj3gClR5mox0qi/MrJnzSv1ZpbTPwqgjrk4p5PEayBDZbQoliJ
 pdpbuJ4J55bgpufPFkRA+0Ryf7yq1sw4RjDMorUF73S0u9I/t050MW6Qsgw0vI0c/zDX
 3rdoWIk6GTzV7n7qSLrYe34K0U1liFOOSRS6L2uYzb77rflP7qLRy77mLjiyNIIa/UyT
 whsw==
X-Gm-Message-State: AHPjjUjqN23ro/87NBVt6WRvVzo4iNJkDr52iJYCxEWKlzbc3FjCvUuy
 lqhJdciBdgZcFrRJOxievM38kqkw
X-Google-Smtp-Source: AOwi7QANArziLC1dwDk+mTsdpQAglD3SX722x8jsI+3QmSvLw4aPA3r+NGw4yUnRy3+0Au9evAH3aQ==
X-Received: by 10.28.236.25 with SMTP id k25mr12066091wmh.146.1506959700628;
 Mon, 02 Oct 2017 08:55:00 -0700 (PDT)
Received: from [172.16.8.139] (host-78-151-241-248.as13285.net.
 [78.151.241.248])
 by smtp.gmail.com with ESMTPSA id v80sm9493740wmv.37.2017.10.02.08.54.59
 for <28670 <at> debbugs.gnu.org>
 (version=TLS1_2 cipher=ECDHE-RSA-AES128-GCM-SHA256 bits=128/128);
 Mon, 02 Oct 2017 08:55:00 -0700 (PDT)
To: 28670 <at> debbugs.gnu.org
From: Alan Jenkins <alan.christopher.jenkins@HIDDEN>
Subject: Re: df: detection of overmounted filesystems is not quite complete
Message-ID: <650bafdc-2c75-0ec1-3e9f-92bf270e029f@HIDDEN>
Date: Mon, 2 Oct 2017 16:54:58 +0100
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:52.0) Gecko/20100101
 Thunderbird/52.3.0
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Transfer-Encoding: 8bit
Content-Language: en-GB
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 28670
X-Mailman-Approved-At: Mon, 02 Oct 2017 12:57:54 -0400
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)

 > Report bugs, including version and distribution variant, to the list ...

oops.  Fedora Linux 26:

$ rpm -q --whatprovides `which df`
coreutils-8.27-6.fc26.x86_64





Information forwarded to bug-coreutils@HIDDEN:
bug#28670; Package coreutils. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 2 Oct 2017 16:57:56 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Oct 02 12:57:56 2017
Received: from localhost ([127.0.0.1]:44434 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1dz42V-0006Ps-Mk
	for submit <at> debbugs.gnu.org; Mon, 02 Oct 2017 12:57:56 -0400
Received: from eggs.gnu.org ([208.118.235.92]:47639)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <alan.christopher.jenkins@HIDDEN>)
 id 1dyzpq-0004Br-8T
 for submit <at> debbugs.gnu.org; Mon, 02 Oct 2017 08:28:34 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <alan.christopher.jenkins@HIDDEN>)
 id 1dyzpi-0007eF-0F
 for submit <at> debbugs.gnu.org; Mon, 02 Oct 2017 08:28:29 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-0.5 required=5.0 tests=BAYES_05,FREEMAIL_FROM,
 T_DKIM_INVALID autolearn=disabled version=3.3.2
Received: from lists.gnu.org ([2001:4830:134:3::11]:45634)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <alan.christopher.jenkins@HIDDEN>)
 id 1dyzph-0007e5-TB
 for submit <at> debbugs.gnu.org; Mon, 02 Oct 2017 08:28:25 -0400
Received: from eggs.gnu.org ([2001:4830:134:3::10]:38582)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <alan.christopher.jenkins@HIDDEN>)
 id 1dyzpc-0005bb-U0
 for bug-coreutils@HIDDEN; Mon, 02 Oct 2017 08:28:25 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <alan.christopher.jenkins@HIDDEN>)
 id 1dyzpZ-0007aR-OT
 for bug-coreutils@HIDDEN; Mon, 02 Oct 2017 08:28:20 -0400
Received: from mail-wr0-x22b.google.com ([2a00:1450:400c:c0c::22b]:56618)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_128_CBC_SHA1:16)
 (Exim 4.71) (envelope-from <alan.christopher.jenkins@HIDDEN>)
 id 1dyzpZ-0007Zu-IF
 for bug-coreutils@HIDDEN; Mon, 02 Oct 2017 08:28:17 -0400
Received: by mail-wr0-x22b.google.com with SMTP id r74so3767968wrb.13
 for <bug-coreutils@HIDDEN>; Mon, 02 Oct 2017 05:28:17 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=subject:from:to:references:message-id:date:user-agent:mime-version
 :in-reply-to:content-transfer-encoding:content-language;
 bh=leo3CxxUWQcaoFFy1am1/dBBzPIDF1xGvctwkzRVYf8=;
 b=dWuFchcIFD0MoioyF0SaDHhjWZMvUlyMLqM5/aE/UYWEznAfGxha56Pb1UXQdGK51o
 h8ZLzYOT6rKADtgnOHs2cRSZkOTmLyA6CdzB5uwJb/161HlYjhtIm8u44k2IBl7pQYwq
 Fihg+0NYnv2icUlm5Lbz1k21aH0YQW+Wbdxaqy8vtb4yQusskNRgDae+4sCRJclJQacr
 ixAMF7bv9JI8V+Xn7xbypfxiCrqEg1ysjyMCJ7Sm495kk/scmZD3jnC41lz978oJ8oq/
 ulP5hxOGd7M7Uq4mMN6dv7YBX7JUle52l+5jrdP3Zq24y7cHKxg93G8wd2am/swGboez
 JaCA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:subject:from:to:references:message-id:date
 :user-agent:mime-version:in-reply-to:content-transfer-encoding
 :content-language;
 bh=leo3CxxUWQcaoFFy1am1/dBBzPIDF1xGvctwkzRVYf8=;
 b=p/mVdelCoC+OGuvSRAXHOa0uMfG+iXOwFcmIrx8TgWe3Yb8DoGGUa8DfRDAvARnD8d
 NNytwo5ioOHcqjWxrkrFUrR/cvx9Q50KJwcIVN9bw3J3tteuWkI2DGrEgDYPgUEtga+V
 yynoB8xn1sSmXeI/onTKmQpBuyZCxvwf/4qhjkDBwLm9efQhnDMpcpRz//rSmleXariL
 sOnrVLRR4qXCxnGMwazy75hlP2pNS55WbKKydbEjWmyKKd49A4M5QF8IGjq5IiShD0Qp
 bJ6Lx0Wv24O9mVrEFF9DRJRFfrJA5oMq6AUEMvh4GwHmGt5CJfeWWCdwegSFD5zm2NG7
 +JzA==
X-Gm-Message-State: AHPjjUhIneC+Lsg8sCctoD8HqyCwvYNVZWXCVU7pZWptyLaJYfpgNYCm
 La/oLQJi7q9atnxfQEaNy9m6XGBj
X-Google-Smtp-Source: AOwi7QCBEg2TRzKakO6XAykiw2CkYFR5xIGTBy99xZiiICQYW85hPIin9t4Mf6S/JNqW6QEO7G5voQ==
X-Received: by 10.223.162.199 with SMTP id t7mr15809798wra.151.1506947295802; 
 Mon, 02 Oct 2017 05:28:15 -0700 (PDT)
Received: from [172.16.1.130] (host-78-151-241-248.as13285.net.
 [78.151.241.248])
 by smtp.gmail.com with ESMTPSA id 31sm2953234wrm.0.2017.10.02.05.28.15
 for <bug-coreutils@HIDDEN>
 (version=TLS1_2 cipher=ECDHE-RSA-AES128-GCM-SHA256 bits=128/128);
 Mon, 02 Oct 2017 05:28:15 -0700 (PDT)
Subject: Re: df: detection of overmounted filesystems is not quite complete
From: Alan Jenkins <alan.christopher.jenkins@HIDDEN>
To: bug-coreutils@HIDDEN
References: <f1ae9f61-ed14-e3d4-4311-84fb549f8d49@HIDDEN>
Message-ID: <e9ae425c-204e-5db0-31c6-285112b7af1b@HIDDEN>
Date: Mon, 2 Oct 2017 13:28:14 +0100
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:52.0) Gecko/20100101
 Thunderbird/52.3.0
MIME-Version: 1.0
In-Reply-To: <f1ae9f61-ed14-e3d4-4311-84fb549f8d49@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Transfer-Encoding: 8bit
Content-Language: en-GB
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
 recognized.
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 2001:4830:134:3::11
X-Spam-Score: -4.0 (----)
X-Debbugs-Envelope-To: submit
X-Mailman-Approved-At: Mon, 02 Oct 2017 12:57:54 -0400
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -4.0 (----)

$ rpm -q --whatprovides `which df`
coreutils-8.27-6.fc26.x86_64

(Fedora Linux 26)


On 02/10/17 13:27, Alan Jenkins wrote:
> Scenario 1 - lovely diagnostic
>
> $ df -h /dev/sda1
> df: cannot access '/dev/sda1': over-mounted by another device
>
> $ mount | grep boot/efi
> /dev/sda6 on /boot type ext4 (rw,relatime,seclabel,data=ordered)
> /dev/sda1 on /boot/efi type vfat 
> (rw,relatime,fmask=0077,dmask=0077,codepage=437,iocharset=ascii,shortname=winnt,errors=remount-ro)
> none on /boot/efi type tmpfs (rw,relatime,seclabel)
>
>
> Scenario 2 - breaks down
>
> $ df -h |grep /dev/sda1
> $ df -ah |grep /dev/sda1
> /dev/sda1                             -     -     -    - /boot/efi
>
> above is consistent (same output as in scenario 1), but below is bad:
>
> $ df -h /dev/sda1  # or same output  from `/boot/efi`
> Filesystem      Size  Used Avail Use% Mounted on
> /dev/sda1       3.9G     0  3.9G   0% /boot/efi
>
> Case 2 situation is as follows:
>
> $ mount | grep boot
> /dev/sda6 on /boot type ext4 (rw,relatime,seclabel,data=ordered)
> /dev/sda1 on /boot/efi type vfat 
> (rw,relatime,fmask=0077,dmask=0077,codepage=437,iocharset=ascii,shortname=winnt,errors=remount-ro)
> none on /boot type tmpfs (rw,relatime,seclabel)
>
> i.e. the tmpfs on /boot is the most recent mount, masking the 
> /boot/efi mount (and I created a dummy `/boot/efi` directory in the 
> tmpfs).
>
> The practical use-case is that people get very confused when their 
> distribution sets up pam_ecryptfs.  If `df` was more reliable about 
> detecting overmounts, then it would provide better diagnostics for 
> when pam_ecryptfs overmounts a filesystem which was mounted by fstab.
>
> https://unix.stackexchange.com/questions/370043/mounting-a-subdirectory-of-home-onto-an-own-partition-confuses-disk-usage-report/395630?noredirect=1#comment706009_395630 
>





Information forwarded to bug-coreutils@HIDDEN:
bug#28670; Package coreutils. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 2 Oct 2017 15:37:04 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Oct 02 11:37:04 2017
Received: from localhost ([127.0.0.1]:44343 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1dz2mF-0004Lv-Ib
	for submit <at> debbugs.gnu.org; Mon, 02 Oct 2017 11:37:04 -0400
Received: from eggs.gnu.org ([208.118.235.92]:47133)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <alan.christopher.jenkins@HIDDEN>)
 id 1dyzoh-00049r-JV
 for submit <at> debbugs.gnu.org; Mon, 02 Oct 2017 08:27:23 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <alan.christopher.jenkins@HIDDEN>)
 id 1dyzoY-00072b-6y
 for submit <at> debbugs.gnu.org; Mon, 02 Oct 2017 08:27:18 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-1.9 required=5.0 tests=BAYES_00,FREEMAIL_FROM,
 T_DKIM_INVALID autolearn=disabled version=3.3.2
Received: from lists.gnu.org ([2001:4830:134:3::11]:40025)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <alan.christopher.jenkins@HIDDEN>)
 id 1dyzoY-00072V-3E
 for submit <at> debbugs.gnu.org; Mon, 02 Oct 2017 08:27:14 -0400
Received: from eggs.gnu.org ([2001:4830:134:3::10]:38046)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <alan.christopher.jenkins@HIDDEN>)
 id 1dyzoW-0005QE-PN
 for bug-coreutils@HIDDEN; Mon, 02 Oct 2017 08:27:13 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <alan.christopher.jenkins@HIDDEN>)
 id 1dyzoQ-0006zC-Qz
 for bug-coreutils@HIDDEN; Mon, 02 Oct 2017 08:27:12 -0400
Received: from mail-wm0-x234.google.com ([2a00:1450:400c:c09::234]:49106)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_128_CBC_SHA1:16)
 (Exim 4.71) (envelope-from <alan.christopher.jenkins@HIDDEN>)
 id 1dyzoQ-0006y9-KS
 for bug-coreutils@HIDDEN; Mon, 02 Oct 2017 08:27:06 -0400
Received: by mail-wm0-x234.google.com with SMTP id i82so8078754wmd.3
 for <bug-coreutils@HIDDEN>; Mon, 02 Oct 2017 05:27:05 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=to:from:subject:message-id:date:user-agent:mime-version
 :content-transfer-encoding:content-language;
 bh=Yj06k/0t0ayMXKt9OocNXlgSVdWtJBARzkr13928OYo=;
 b=EMk86+hYkHIW7QmSV8UPOGVYpOq54bM5zW3yoemQdZgHwAdq1Phifd/460nI7/Ldt2
 U9dax6yg6YVKQ76RtYmXv8/3AHyX5cAGkdg2YxTH+AYSSoy9qvqSHaEzyrbWe279dBp5
 J1lP9Wfbv77iuQn39IOhITOYOb+AAmw4QsVLd5i37CqDLB7pntQn4jQSGgFdqA3QQ8q9
 izKez0MKlPSgh938a0jZE8R9rH3jx7TLdnaGx4mFVOGQGljXhfzLWvFJ6YHV9sqkR3s8
 lZnj9ktkUz5CLXMn4JT3QHEUmAXRzqRHi3r6Bcf2CJL81G/bVMQ8yAkb5DM39PqslNNd
 kJCA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:to:from:subject:message-id:date:user-agent
 :mime-version:content-transfer-encoding:content-language;
 bh=Yj06k/0t0ayMXKt9OocNXlgSVdWtJBARzkr13928OYo=;
 b=Evz/gDtkl5b8ti5w2sqhci4fqobU98lWhU6gLna8SlnrVGCNROh0UJ059ZDyQVfkPW
 YNTQ1vz80Da47zdfRByzM7MErYyopkYbalm1TdwaKwetMUdCGH2hz5UogFsWUSiKyifz
 qN+zqc8a1hkdNP7nEqmgn1SfxnPRc6Y+BQbRCeE3wAHC2/IbPQVYjrtPA+kwmwUS0A1r
 tHWD/gkEZDuUQMQUvfkatD/plC3N7W0W3MZYL4LT/AIDH45UcdviJlHAB3hXWV2LdFYn
 2CLZmPSjqCu3SjHfyRkkIAkxCxxyjDZ+SbqqrsMGltoTROMQ2pnLRQadarIJCCX7alAH
 zWrw==
X-Gm-Message-State: AHPjjUiAiAcD+eJiQ80mS9Acwk+qyErxQNv7WJu4CWW0AYVzR07HvcEW
 KA9pmN5SU8XH50jYg8uxW+FGVq9W
X-Google-Smtp-Source: AOwi7QAMi7c1RZjVD97I1YgToTVHjwxWTbH3HQuVle8G8K3VHYvkrjuqji6pqGIcRY1bxKO/qfLy3g==
X-Received: by 10.28.153.85 with SMTP id b82mr9128449wme.121.1506947224062;
 Mon, 02 Oct 2017 05:27:04 -0700 (PDT)
Received: from [172.16.1.130] (host-78-151-241-248.as13285.net.
 [78.151.241.248])
 by smtp.gmail.com with ESMTPSA id 65sm4223232wro.25.2017.10.02.05.27.02
 for <bug-coreutils@HIDDEN>
 (version=TLS1_2 cipher=ECDHE-RSA-AES128-GCM-SHA256 bits=128/128);
 Mon, 02 Oct 2017 05:27:03 -0700 (PDT)
To: bug-coreutils@HIDDEN
From: Alan Jenkins <alan.christopher.jenkins@HIDDEN>
Subject: df: detection of overmounted filesystems is not quite complete
Message-ID: <f1ae9f61-ed14-e3d4-4311-84fb549f8d49@HIDDEN>
Date: Mon, 2 Oct 2017 13:27:02 +0100
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:52.0) Gecko/20100101
 Thunderbird/52.3.0
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Transfer-Encoding: 8bit
Content-Language: en-GB
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
 recognized.
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 2001:4830:134:3::11
X-Spam-Score: -4.0 (----)
X-Debbugs-Envelope-To: submit
X-Mailman-Approved-At: Mon, 02 Oct 2017 11:37:03 -0400
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -4.0 (----)

Scenario 1 - lovely diagnostic

$ df -h /dev/sda1
df: cannot access '/dev/sda1': over-mounted by another device

$ mount | grep boot/efi
/dev/sda6 on /boot type ext4 (rw,relatime,seclabel,data=ordered)
/dev/sda1 on /boot/efi type vfat 
(rw,relatime,fmask=0077,dmask=0077,codepage=437,iocharset=ascii,shortname=winnt,errors=remount-ro)
none on /boot/efi type tmpfs (rw,relatime,seclabel)


Scenario 2 - breaks down

$ df -h |grep /dev/sda1
$ df -ah |grep /dev/sda1
/dev/sda1                             -     -     -    - /boot/efi

above is consistent (same output as in scenario 1), but below is bad:

$ df -h /dev/sda1  # or same output  from `/boot/efi`
Filesystem      Size  Used Avail Use% Mounted on
/dev/sda1       3.9G     0  3.9G   0% /boot/efi

Case 2 situation is as follows:

$ mount | grep boot
/dev/sda6 on /boot type ext4 (rw,relatime,seclabel,data=ordered)
/dev/sda1 on /boot/efi type vfat 
(rw,relatime,fmask=0077,dmask=0077,codepage=437,iocharset=ascii,shortname=winnt,errors=remount-ro)
none on /boot type tmpfs (rw,relatime,seclabel)

i.e. the tmpfs on /boot is the most recent mount, masking the /boot/efi 
mount (and I created a dummy `/boot/efi` directory in the tmpfs).

The practical use-case is that people get very confused when their 
distribution sets up pam_ecryptfs.  If `df` was more reliable about 
detecting overmounts, then it would provide better diagnostics for when 
pam_ecryptfs overmounts a filesystem which was mounted by fstab.

https://unix.stackexchange.com/questions/370043/mounting-a-subdirectory-of-home-onto-an-own-partition-confuses-disk-usage-report/395630?noredirect=1#comment706009_395630




Acknowledgement sent to Alan Jenkins <alan.christopher.jenkins@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-coreutils@HIDDEN. Full text available.
Report forwarded to bug-coreutils@HIDDEN:
bug#28670; Package coreutils. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Tue, 30 Oct 2018 01:45:01 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.